<template>
  <!-- <v-layout row justify-center> -->
  <v-app>
    <v-toolbar
      color="#6a7d69"
      style="opacity:0.78; margin-bottom:20px;"
      app
      class="elevation-1"
    >
      <v-btn flat small style="color:white;" @click="backpage">
        <v-icon>mdi-keyboard-backspace</v-icon>
        <span
          style="margin-left: 4px;font-size: 14px;font-family: Sarabun, sans-serif;"
          >กลับสู่เมนูหลัก</span
        >
      </v-btn>
      <v-toolbar-title></v-toolbar-title>
      <v-spacer></v-spacer>
    </v-toolbar>
    <!-- <center>
       <img style="width:120px; height:120px; margin-top:100px;" :src="images.success"/>
      <h3 style="text-transform: uppercase; margin-top:40px;">Your transfer is processing</h3>
    </center> -->
    <!-- DESKTOP View -->
    <v-layout v-if="!mobileView" justify-center style="margin-top:100px;">
      <v-flex xs10 md10 style="padding:60px;">
        <v-card style="border-radius:20px; height:auto;">
          <v-layout justify-center>
            <v-flex xs6 md6>
              <v-layout>
                <v-flex md2 xs2></v-flex>
                <v-flex md5 xs5>
                  <p
                    style="color:#6a7d69; margin:20px; font-weight:bold; font-size:15px;font-family: Sarabun, sans-serif;"
                    v-if="!mobileView"
                  >
                    Transaction Ref No.<br />
                    Transaction Date<br />
                    Payment Amount<br />
                    Payment Result<br />
                  </p>
                </v-flex>
                <v-flex md5 xs5>
                  <p
                    style="color:#626262; margin:20px; font-size:15px; font-weight:bold;font-family: Sarabun, sans-serif;"
                    v-if="!mobileView"
                  >
                    {{ transview.payment_ref }}<br />
                    {{ transview.paymentDate }}<br />
                    {{ transview.payAmount }} THB<br />
                    <v-chip
                      :color="
                        transactiondata.rcode === '0'
                          ? 'success'
                          : transactiondata.rcode === '1'
                          ? 'red'
                          : transactiondata.rcode === '2'
                          ? 'warning'
                          : 'grey'
                      "
                      v-if="transactiondata.rcode"
                      text-color="white"
                      text-size="117%"
                      >{{ transactiondata.payment_status }}
                    </v-chip>
                  </p>
                </v-flex>
              </v-layout>
              <!-- </v-card> -->
            </v-flex>
          </v-layout>
          <v-layout justify-center>
            <v-flex xs8 py-4>
              <v-data-table
                class="elevation-0 table-style"
                :headers="headers"
                :items="invoiceview"
                item-key="description"
                hide-actions
              >
                <template v-slot:items="props">
                  <tr>
                    <td class="text-xs-center" data-label="No.">
                      {{ props.index + 1 }}
                    </td>
                    <td data-label="Doc No.">
                      <strong style="color:#6a7d69;">{{
                        props.item.order_id
                      }}</strong>
                    </td>
                    <td data-label="Company Name">
                      {{ props.item.receiver_company }}
                    </td>
                    <td data-label="Amount">{{ props.item.grandTotal }}</td>
                  </tr>
                </template>
              </v-data-table>
            </v-flex>
          </v-layout>
        </v-card>
      </v-flex>
    </v-layout>
    <!-- Mobile View -->
    <!-- <p style="font-size:14px; color:#6a7d69; font-family:'Roboto'; margin-left:20px; margin-right:50px;" align="left" v-if="mobileView">
    Transaction Reference :&nbsp;&nbsp; <strong>{{ transsaction_ref }}</strong>
    <br />
    Transaction Date. :&nbsp;&nbsp; <strong>{{ datetime }}</strong>
    <br />
    Payment Amount (THB) :&nbsp;&nbsp; <strong>{{ pay_amount }}</strong>
    <br />
    Payment Transaction Number :&nbsp;&nbsp; <strong>{{ payment_transaction_no }}</strong>
    </p> -->

    <v-layout v-if="mobileView" justify-center style="margin-top:100px;">
      <v-flex xs12 md12 style="padding:10px;">
        <v-card style="border-radius:20px; height:auto;">
          <v-layout>
            <v-flex>
              <v-layout xs6 md6>
                <v-flex md12 xs4>
                  <p
                    style="color:#6a7d69; margin:40px 0 0 40px; font-weight:bold; font-size:14px;font-family: Sarabun, sans-serif;"
                  >
                    Transaction Reference No.
                    <br />
                    Transaction Date
                    <br />
                    Payment Amount (THB)
                    <br />
                    Payment Result<br />
                  </p>
                </v-flex>
                <v-flex md8>
                  <p
                    style="color:#626262; margin-top:40px; font-size:15px; font-weight:bold;font-family: Sarabun, sans-serif;"
                    v-if="mobileView"
                  >
                    {{ transview.payment_ref }}
                    <br />
                    {{ transview.paymentDate }}
                    <br />
                    {{ transview.payAmount }}
                    <br />
                    <v-chip
                      :color="
                        transactiondata.rcode === '0'
                          ? 'success'
                          : transactiondata.rcode === '1'
                          ? 'red'
                          : transactiondata.rcode === '2'
                          ? 'warning'
                          : 'grey'
                      "
                      v-if="transactiondata.rcode"
                      text-color="white"
                      text-size="100%"
                      >{{ transactiondata.payment_status }}
                    </v-chip>
                  </p>
                </v-flex>
              </v-layout>
              <!-- </v-card> -->
            </v-flex>
          </v-layout>
          <v-layout>
            <v-flex xs12 py-4 style="padding-left:20px;padding-right:20px;">
              <v-data-table
                class="elevation-0 table-style"
                :headers="headers"
                :items="invoiceview"
                item-key="order_id"
                hide-actions
              >
                <template v-slot:items="props">
                  <tr>
                    <td class="text-xs-center" data-label="No.">
                      {{ props.index + 1 }}
                    </td>
                    <td data-label="Doc No.">
                      <strong style="color:#6a7d69;">{{
                        props.item.order_id
                      }}</strong>
                    </td>
                    <td data-label="Company Name">
                      {{ props.item.receiver_company }}
                    </td>
                    <td data-label="Amount">{{ props.item.grand_total }}</td>
                  </tr>
                </template>
              </v-data-table>
            </v-flex>
          </v-layout>
        </v-card>
      </v-flex>
    </v-layout>
  </v-app>
</template>

<script>
import { sync } from "vuex-pathify";
// import Invoicemodal from '@/components/Invoicemodal'
import moment from "moment";
moment.locale("en");
export default {
  components: {
    // Invoicemodal
  },
  data() {
    return {
      username: this.$cookies.get("username"),
      dialoginvite: false,
      datetime: "",
      time_t: "",
      mobileView: false,
      token: "",
      dialogloader: false,
      notifications: false,
      sound: true,
      widgets: false,
      transactiondata: [],
      invoicedata: [],
      tempinvoices: [],
      images: {
        logo: require("../assets/inetlogo.png"),
        signup: require("../assets/signup.png"),
        joinus: require("../assets/joinus.png"),
        success: require("../assets/success.png"),
        cancel: require("../assets/close.png"),
        fail: require("../assets/fail.png")
      },
      headers: [
        { text: "No.", value: "index", sortable: false, align: "center" },
        {
          text: "Doc No.",
          value: "order_id",
          align: "left",
          sortable: false
        },
        {
          text: "Company Name",
          value: "receiver_company",
          align: "left",
          sortable: false
        },
        {
          text: "Grand Total(THB)",
          value: "grand_total",
          align: "left",
          sortable: false
        }
      ],
      data_sandbox: []
    };
  },
  methods: {
    backpage() {
      this.$router.push("/unpaidbill");
    },

    async gettransactiondata() {
      try {
        var { data } = await this.axios.get(
          `${process.env.VUE_APP_APIHOST}/latest_transaction`,
          {
            headers: { Authorization: this.token }
          }
        );
        this.transactiondata = data;
        // console.log(this.transactiondata);
        this.transactiondata = data.transaction;
        this.invoicedata = data.invoices;

        for (let index = 0; index < this.invoicedata.length; index++) {
          const element = this.invoicedata[index];

          if (element) {
            this.data_sandbox.push(element.order_id);
          }
        }

        let host = "";
        host = process.env.VUE_APP_APIHOST;

        let host_split = host.split("//");

        let arr = host_split[1].substring(0, 3);

        // if (arr == "uat") {
        this.$cookies.set("status_sandbox", "receiver_directcredit");

        let routeData = this.$router.resolve({
          name: "sandbox",
          query: { data: this.data_sandbox }
        });
        window.open(routeData.href, "_blank");
        // }
      } catch (error) {
        console.log(error.message);
      }
    },
    addCommas(nStr) {
      nStr += "";
      var x = nStr.split(".");
      var x1 = x[0];
      var x2 = x.length > 1 ? "." + x[1] : "";
      var rgx = /(\d+)(\d{3})/;
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, "$1" + "," + "$2");
      }
      return x1 + x2;
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
      // this.$cookies.set('screenView', this.mobileView)
    }
  },
  computed: {
    invoiceview() {
      return this.invoicedata.map(inv => {
        return {
          ...inv,
          grandTotal: this.addCommas(inv.grand_total.toFixed(2))
        };
      });
    },
    transview() {
      return {
        ...this.transactiondata,
        payAmount: this.addCommas(
          parseFloat(this.transactiondata.pay_amount).toFixed(2)
        ),
        paymentDate: moment(this.transactiondata.createdAt).format(
          "D MMMM YYYY, HH:mm:ss"
        )
      };
    }
  },
  created() {
    this.handleView();
    // console.log('aaa');
    //  if (this.username == 'Guest'){
    //     this.dialoginvite = true
    // }
    // console.log('created transaction: ', this.$route);
    // this.gettransactiondata()

    if (this.$route.query.authorization) {
      // console.log('bb');
      this.token = this.$route.query.authorization;
      // console.log("transactionResult?transactionNo: ", this.token);
      this.gettransactiondata();
    } else {
      this.$router.push("/");
    }
  }
};
</script>
<style scoped>
.headline {
  padding: 3% 0 0 40%;
  text-align: center;
}
.successTxt {
  color: green;
}
.cancelTxt {
  color: red;
}
.failTxt {
  color: orange;
}
.pendingTxt {
  color: black;
}
</style>
